/**
 *
 */
package org.objectweb.easybeans.jsr77;

import java.util.Map;

import javax.management.MBeanException;
import javax.management.RuntimeOperationsException;

import org.objectweb.easybeans.api.EZBContainer;
import org.objectweb.easybeans.api.EZBServer;
import org.objectweb.easybeans.jmx.MBeansException;
import org.objectweb.easybeans.jmx.MBeansHelper;

/**
 * J2EEServer MBean for JSR 77.
 * @author Guillaume Sauthier
 */
public class J2EEServerMBean extends J2EEManagedObjectMBean<EZBServer> {

    /**
     * @throws MBeanException if creation fails
     * @throws RuntimeOperationsException if creation fails
     */
    public J2EEServerMBean() throws MBeanException, RuntimeOperationsException {
        super();
    }

    /**
     * @return Returns the ObjectNames of the deployed objects.
     */
    public String[] getDeployedObjects() {
        Map<String, EZBContainer> containers = getManagedComponent().getContainers();
        int size = containers.size();
        String[] deployedObjects = new String[size];

        int index = 0;
        for(EZBContainer container : containers.values()) {

            try {
                deployedObjects[index] = MBeansHelper.getInstance().getObjectName(container);
            } catch (MBeansException e) {
                deployedObjects[index] = "";
            }

            index++;
        }

        return deployedObjects;
    }

    /**
     * non-sens in EasyBeans.
     * @return Returns the ObjectName of the deployed Resources.
     */
    public String[] getResources() {
        // TODO to be implemented
        throw new UnsupportedOperationException("Not implemented yet !");
    }

    /**
     * @return Returns the ObjectNames of the Java VMs.
     */
    public String[] getJavaVMs() {
        // TODO to be implemented
        throw new UnsupportedOperationException("Not implemented yet !");
    }

    /**
     * @return Returns the Server Vendor name.
     */
    public String getServerVendor() {
        return "Objectweb";
    }

    /**
     * @return Returns the Server version.
     */
    public String getServerVersion() {
        return "Preview";
    }

}
