/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ItfSessionBeanTester.java 878 2006-07-17 09:14:42Z pinheirg $
 * --------------------------------------------------------------------------
 */

package org.objectweb.easybeans.tests.common.ejbs.stateless.containermanaged.basic;

/**
 * Verifies if the deploy works well when the bean has meny method with the same name.
 * @author Gisele Pinheiro Souza
 * @author Eduardo Studzinski Estima de Castro
 *
 */
public interface ItfSessionBeanTester {

    /**
     * Calls the method getDefaultMessage() of the stateless bean that was
     * injected.
     */
    void testSLSBByInjection();

    /**
     * Calls the method getDefaultMessage() of the stateless bean that was goten
     * by lookup.
     * @throws Exception if a lokkup error occurs.
     */
    void testSLSBByLookup() throws Exception;

    /**
     * Calls the method getDefaultMessage() of the stateful bean that was
     * injected.
     */
    void testSFSBByInjection();

    /**
     * Calls the method getDefaultMessage() of the stateful bean that was goten
     * by lookup.
     * @throws Exception if a lokkup error occurs.
     */
    void testSFSBByLookup() throws Exception;

}
